"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert = __importStar(require("assert"));
const tl = require("azure-pipelines-task-lib/task");
const ts_mock_imports_1 = require("ts-mock-imports");
const ReleaseEnvironmentVariables_1 = __importDefault(require("../src/ReleaseEnvironmentVariables"));
describe("release", function () {
    const arbitraryAttemptNumber = "arbitraryAuthToken";
    const arbitraryDefinitionName = "arbitraryDefinitionName";
    const arbitraryEnvironmentId = "arbitraryEnvironmentId";
    const arbitraryEnvironmentName = "arbitraryEnvironmentName";
    const arbitraryReleaseId = "arbitraryReleaseId";
    const arbitraryReleaseName = "arbitraryReleaseName";
    const arbitraryReleaseWebUrl = "arbitraryReleaseWebUrl";
    const arbitraryAccessToken = "arbitraryAccessToken";
    const arbitraryReleaseStartTime = new Date().toISOString().replace('T', ' ');
    beforeEach(function () {
        let getVariableStub = ts_mock_imports_1.ImportMock.mockFunction(tl, "getVariable");
        getVariableStub.withArgs("Release.AttemptNumber").returns(arbitraryAttemptNumber);
        getVariableStub.withArgs("Release.DefinitionName").returns(arbitraryDefinitionName);
        getVariableStub.withArgs("Release.EnvironmentId").returns(arbitraryEnvironmentId);
        getVariableStub.withArgs("Release.EnvironmentName").returns(arbitraryEnvironmentName);
        getVariableStub.withArgs("Release.ReleaseId").returns(arbitraryReleaseId);
        getVariableStub.withArgs("Release.ReleaseName").returns(arbitraryReleaseName);
        getVariableStub.withArgs("Release.ReleaseWebURL").returns(arbitraryReleaseWebUrl);
        getVariableStub.withArgs("Release.Deployment.StartTime").returns(arbitraryReleaseStartTime);
        let getEndpointAuthorizationParameterStub = ts_mock_imports_1.ImportMock.mockFunction(tl, "getEndpointAuthorizationParameter");
        getEndpointAuthorizationParameterStub.withArgs("SystemVssConnection", "AccessToken", true).returns(arbitraryAccessToken);
    });
    afterEach(function () {
        ts_mock_imports_1.ImportMock.restore();
    });
    describe("when newed up", function () {
        it('populates populates all the properties from the Task Library calls', () => __awaiter(this, void 0, void 0, function* () {
            let release = new ReleaseEnvironmentVariables_1.default();
            assert.strictEqual(release.attemptNumber, arbitraryAttemptNumber, "invalid attempt number");
            assert.strictEqual(release.definitionName, arbitraryDefinitionName, "invalid definition name");
            assert.strictEqual(release.environmentId, arbitraryEnvironmentId, "invalid environment id");
            assert.strictEqual(release.environmentName, arbitraryEnvironmentName, "invalid environment name");
            assert.strictEqual(release.id, arbitraryReleaseId, "invalid release id");
            assert.strictEqual(release.name, arbitraryReleaseName, "invalid release name");
            assert.strictEqual(release.link, arbitraryReleaseWebUrl, "invalid release web url");
            assert.strictEqual(release.startTime, arbitraryReleaseStartTime);
            assert.strictEqual(release.accessToken, arbitraryAccessToken);
        }));
    });
});
//# sourceMappingURL=ReleaseEnvironmentVariables-tests.js.map